

    /* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
    *                                                                 *
    *   AutoAppend Proton Plugin 1.4                                  *
    *   Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>   *
    *                                                                 *
    *   --> http://www.hartwork.org                                   *
    *                                                                 *
    *                                                                 *
    *   This source code is released under LGPL.                      *
    *   See LGPL.txt for details.                        2004-10-05   *
    *                                                                 *
    \* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */



#include "engine.h"



/******************************************************************************************************
**  engine                                                                                           **
******************************************************************************************************/

bool engine( char * in, char * & out, char * app, UINT uExtra )
{
	UINT in_len   = strlen( in );
	UINT out_len  = 0;
	UINT app_len  = strlen( app );


	char * szWalker = in;
	bool b13before = false;
	UINT uLines = 0;


	// (I) Count lines (to predict size of output)
	while( *szWalker != '\0' )
	{
		switch( *szWalker )
		{
			case '\x0D':
			{
				b13before = true;
				
				break;
			}
			case '\x0A':
			{
				if( b13before )
				{
					uLines++;
				}

				b13before = false;

				break;
			}
			default:
			{
				b13before = false;
			}
		}

		szWalker++;
	}

	// Finishing newline?
	bool bNewlineFinish =	( in_len >= 2 ) &&
							( *( szWalker - 2 ) == '\x0D' ) &&
							( *( szWalker - 1 ) == '\x0A' );
	if( !bNewlineFinish )
	{
		uLines++;
	}

	szWalker = in;		// Reset to start


	// Allocate new buffer
	out = new char[ in_len + ( app_len * uLines ) + 1 + uExtra ];


	// (II) Create new content
	bool bSearching = true;
	char * szBeg = NULL;
	char * szEnd = NULL;
	char * szBegNext = in;

	while( uLines-- )
	{
		// (0) Search end of line/string
		b13before   = false;
		bSearching  = true;

		while( bSearching )
		{
			switch( *szWalker )
			{
				case '\x0D':
				{
					b13before = true;

					break;
				}
				case '\x0A':
				{
					if( b13before )
					{
						bSearching  = false;		// STOP
						b13before   = false;
					}
					
					break;
				}
				case '\0':
				{
					bSearching = false;			// STOP
					szWalker--;					// We only walk _one_ past the end
					
					break;
				}
				default:
				{
					b13before = false;
				}
			}

			szWalker++;
		}


		// (1) Copy line
		szBeg = szBegNext;
		szEnd = szWalker - ( ( uLines || bNewlineFinish ) ? 2 : 0 );

		UINT line_len = szEnd - szBeg;
		if( line_len > 0 )
		{
			memcpy( out + out_len, szBeg, line_len );
			out_len += line_len;
		}
		szBegNext = szEnd;


		// (2) Append
		memcpy( out + out_len, app, app_len );
		out_len += app_len;


		// (3) Rest
		if( !uLines && bNewlineFinish )
		{
			UINT rest_len = ( in + in_len ) - szBegNext;
			memcpy( out + out_len, szBegNext, rest_len );
			out_len += rest_len;
		}
	}

	out[ out_len ] = '\0';

	return true;
}
